<?php
/**
 * ElasticOffer
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\CatalogCacheClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi Catalog Cache
 *
 * Ensi Catalog Cache
 *
 * The version of the OpenAPI document: 1.0.0
 * Contact: mail@greensight.ru
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\CatalogCacheClient\Dto;

use \ArrayAccess;
use \Ensi\CatalogCacheClient\ObjectSerializer;

/**
 * ElasticOffer Class Doc Comment
 *
 * @category Class
 * @package  Ensi\CatalogCacheClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class ElasticOffer implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'ElasticOffer';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'product_id' => 'int',
        'allow_publish' => 'bool',
        'main_image_file' => '\Ensi\CatalogCacheClient\Dto\FileNullable',
        'category_ids' => 'int[]',
        'brand_id' => 'int',
        'name' => 'string',
        'code' => 'string',
        'description' => 'string',
        'type' => 'int',
        'vendor_code' => 'string',
        'barcode' => 'string',
        'weight' => 'float',
        'weight_gross' => 'float',
        'width' => 'float',
        'height' => 'float',
        'length' => 'float',
        'is_adult' => 'bool',
        'uom' => 'int',
        'tariffing_volume' => 'int',
        'order_step' => 'float',
        'order_minvol' => 'float',
        'price' => 'int',
        'cost' => 'int',
        'gluing_name' => 'string',
        'gluing_is_main' => 'bool',
        'gluing_is_active' => 'bool',
        'discount' => '\Ensi\CatalogCacheClient\Dto\ElasticDiscount',
        'brand' => '\Ensi\CatalogCacheClient\Dto\ElasticBrand',
        'categories' => '\Ensi\CatalogCacheClient\Dto\ElasticCategory[]',
        'images' => '\Ensi\CatalogCacheClient\Dto\ElasticImage[]',
        'attributes' => '\Ensi\CatalogCacheClient\Dto\ElasticAttribute[]',
        'gluing' => '\Ensi\CatalogCacheClient\Dto\Gluing[]',
        'nameplates' => '\Ensi\CatalogCacheClient\Dto\ElasticNameplate[]'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'product_id' => null,
        'allow_publish' => null,
        'main_image_file' => null,
        'category_ids' => null,
        'brand_id' => null,
        'name' => null,
        'code' => null,
        'description' => null,
        'type' => null,
        'vendor_code' => null,
        'barcode' => null,
        'weight' => null,
        'weight_gross' => null,
        'width' => null,
        'height' => null,
        'length' => null,
        'is_adult' => null,
        'uom' => null,
        'tariffing_volume' => null,
        'order_step' => null,
        'order_minvol' => null,
        'price' => null,
        'cost' => null,
        'gluing_name' => null,
        'gluing_is_main' => null,
        'gluing_is_active' => null,
        'discount' => null,
        'brand' => null,
        'categories' => null,
        'images' => null,
        'attributes' => null,
        'gluing' => null,
        'nameplates' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'product_id' => false,
        'allow_publish' => false,
        'main_image_file' => true,
        'category_ids' => false,
        'brand_id' => true,
        'name' => false,
        'code' => false,
        'description' => true,
        'type' => false,
        'vendor_code' => false,
        'barcode' => true,
        'weight' => true,
        'weight_gross' => true,
        'width' => true,
        'height' => true,
        'length' => true,
        'is_adult' => false,
        'uom' => true,
        'tariffing_volume' => true,
        'order_step' => true,
        'order_minvol' => true,
        'price' => true,
        'cost' => true,
        'gluing_name' => true,
        'gluing_is_main' => true,
        'gluing_is_active' => true,
        'discount' => false,
        'brand' => false,
        'categories' => false,
        'images' => false,
        'attributes' => false,
        'gluing' => false,
        'nameplates' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::openAPINullables()[$property])) {
            return self::openAPINullables()[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'product_id' => 'product_id',
        'allow_publish' => 'allow_publish',
        'main_image_file' => 'main_image_file',
        'category_ids' => 'category_ids',
        'brand_id' => 'brand_id',
        'name' => 'name',
        'code' => 'code',
        'description' => 'description',
        'type' => 'type',
        'vendor_code' => 'vendor_code',
        'barcode' => 'barcode',
        'weight' => 'weight',
        'weight_gross' => 'weight_gross',
        'width' => 'width',
        'height' => 'height',
        'length' => 'length',
        'is_adult' => 'is_adult',
        'uom' => 'uom',
        'tariffing_volume' => 'tariffing_volume',
        'order_step' => 'order_step',
        'order_minvol' => 'order_minvol',
        'price' => 'price',
        'cost' => 'cost',
        'gluing_name' => 'gluing_name',
        'gluing_is_main' => 'gluing_is_main',
        'gluing_is_active' => 'gluing_is_active',
        'discount' => 'discount',
        'brand' => 'brand',
        'categories' => 'categories',
        'images' => 'images',
        'attributes' => 'attributes',
        'gluing' => 'gluing',
        'nameplates' => 'nameplates'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'product_id' => 'setProductId',
        'allow_publish' => 'setAllowPublish',
        'main_image_file' => 'setMainImageFile',
        'category_ids' => 'setCategoryIds',
        'brand_id' => 'setBrandId',
        'name' => 'setName',
        'code' => 'setCode',
        'description' => 'setDescription',
        'type' => 'setType',
        'vendor_code' => 'setVendorCode',
        'barcode' => 'setBarcode',
        'weight' => 'setWeight',
        'weight_gross' => 'setWeightGross',
        'width' => 'setWidth',
        'height' => 'setHeight',
        'length' => 'setLength',
        'is_adult' => 'setIsAdult',
        'uom' => 'setUom',
        'tariffing_volume' => 'setTariffingVolume',
        'order_step' => 'setOrderStep',
        'order_minvol' => 'setOrderMinvol',
        'price' => 'setPrice',
        'cost' => 'setCost',
        'gluing_name' => 'setGluingName',
        'gluing_is_main' => 'setGluingIsMain',
        'gluing_is_active' => 'setGluingIsActive',
        'discount' => 'setDiscount',
        'brand' => 'setBrand',
        'categories' => 'setCategories',
        'images' => 'setImages',
        'attributes' => 'setAttributes',
        'gluing' => 'setGluing',
        'nameplates' => 'setNameplates'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'product_id' => 'getProductId',
        'allow_publish' => 'getAllowPublish',
        'main_image_file' => 'getMainImageFile',
        'category_ids' => 'getCategoryIds',
        'brand_id' => 'getBrandId',
        'name' => 'getName',
        'code' => 'getCode',
        'description' => 'getDescription',
        'type' => 'getType',
        'vendor_code' => 'getVendorCode',
        'barcode' => 'getBarcode',
        'weight' => 'getWeight',
        'weight_gross' => 'getWeightGross',
        'width' => 'getWidth',
        'height' => 'getHeight',
        'length' => 'getLength',
        'is_adult' => 'getIsAdult',
        'uom' => 'getUom',
        'tariffing_volume' => 'getTariffingVolume',
        'order_step' => 'getOrderStep',
        'order_minvol' => 'getOrderMinvol',
        'price' => 'getPrice',
        'cost' => 'getCost',
        'gluing_name' => 'getGluingName',
        'gluing_is_main' => 'getGluingIsMain',
        'gluing_is_active' => 'getGluingIsActive',
        'discount' => 'getDiscount',
        'brand' => 'getBrand',
        'categories' => 'getCategories',
        'images' => 'getImages',
        'attributes' => 'getAttributes',
        'gluing' => 'getGluing',
        'nameplates' => 'getNameplates'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('product_id', $data, null);
        $this->setIfExists('allow_publish', $data, null);
        $this->setIfExists('main_image_file', $data, null);
        $this->setIfExists('category_ids', $data, null);
        $this->setIfExists('brand_id', $data, null);
        $this->setIfExists('name', $data, null);
        $this->setIfExists('code', $data, null);
        $this->setIfExists('description', $data, null);
        $this->setIfExists('type', $data, null);
        $this->setIfExists('vendor_code', $data, null);
        $this->setIfExists('barcode', $data, null);
        $this->setIfExists('weight', $data, null);
        $this->setIfExists('weight_gross', $data, null);
        $this->setIfExists('width', $data, null);
        $this->setIfExists('height', $data, null);
        $this->setIfExists('length', $data, null);
        $this->setIfExists('is_adult', $data, null);
        $this->setIfExists('uom', $data, null);
        $this->setIfExists('tariffing_volume', $data, null);
        $this->setIfExists('order_step', $data, null);
        $this->setIfExists('order_minvol', $data, null);
        $this->setIfExists('price', $data, null);
        $this->setIfExists('cost', $data, null);
        $this->setIfExists('gluing_name', $data, null);
        $this->setIfExists('gluing_is_main', $data, null);
        $this->setIfExists('gluing_is_active', $data, null);
        $this->setIfExists('discount', $data, null);
        $this->setIfExists('brand', $data, null);
        $this->setIfExists('categories', $data, null);
        $this->setIfExists('images', $data, null);
        $this->setIfExists('attributes', $data, null);
        $this->setIfExists('gluing', $data, null);
        $this->setIfExists('nameplates', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['id'] === null) {
            $invalidProperties[] = "'id' can't be null";
        }
        if ($this->container['product_id'] === null) {
            $invalidProperties[] = "'product_id' can't be null";
        }
        if ($this->container['allow_publish'] === null) {
            $invalidProperties[] = "'allow_publish' can't be null";
        }
        if ($this->container['main_image_file'] === null) {
            $invalidProperties[] = "'main_image_file' can't be null";
        }
        if ($this->container['category_ids'] === null) {
            $invalidProperties[] = "'category_ids' can't be null";
        }
        if ($this->container['brand_id'] === null) {
            $invalidProperties[] = "'brand_id' can't be null";
        }
        if ($this->container['name'] === null) {
            $invalidProperties[] = "'name' can't be null";
        }
        if ($this->container['code'] === null) {
            $invalidProperties[] = "'code' can't be null";
        }
        if ($this->container['description'] === null) {
            $invalidProperties[] = "'description' can't be null";
        }
        if ($this->container['type'] === null) {
            $invalidProperties[] = "'type' can't be null";
        }
        if ($this->container['vendor_code'] === null) {
            $invalidProperties[] = "'vendor_code' can't be null";
        }
        if ($this->container['barcode'] === null) {
            $invalidProperties[] = "'barcode' can't be null";
        }
        if ($this->container['weight'] === null) {
            $invalidProperties[] = "'weight' can't be null";
        }
        if ($this->container['weight_gross'] === null) {
            $invalidProperties[] = "'weight_gross' can't be null";
        }
        if ($this->container['width'] === null) {
            $invalidProperties[] = "'width' can't be null";
        }
        if ($this->container['height'] === null) {
            $invalidProperties[] = "'height' can't be null";
        }
        if ($this->container['length'] === null) {
            $invalidProperties[] = "'length' can't be null";
        }
        if ($this->container['is_adult'] === null) {
            $invalidProperties[] = "'is_adult' can't be null";
        }
        if ($this->container['uom'] === null) {
            $invalidProperties[] = "'uom' can't be null";
        }
        if ($this->container['tariffing_volume'] === null) {
            $invalidProperties[] = "'tariffing_volume' can't be null";
        }
        if ($this->container['order_step'] === null) {
            $invalidProperties[] = "'order_step' can't be null";
        }
        if ($this->container['order_minvol'] === null) {
            $invalidProperties[] = "'order_minvol' can't be null";
        }
        if ($this->container['price'] === null) {
            $invalidProperties[] = "'price' can't be null";
        }
        if ($this->container['cost'] === null) {
            $invalidProperties[] = "'cost' can't be null";
        }
        if ($this->container['gluing_name'] === null) {
            $invalidProperties[] = "'gluing_name' can't be null";
        }
        if ($this->container['gluing_is_main'] === null) {
            $invalidProperties[] = "'gluing_is_main' can't be null";
        }
        if ($this->container['gluing_is_active'] === null) {
            $invalidProperties[] = "'gluing_is_active' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int $id Offer ID from Offers
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets product_id
     *
     * @return int
     */
    public function getProductId()
    {
        return $this->container['product_id'];
    }

    /**
     * Sets product_id
     *
     * @param int $product_id Product ID from PIM
     *
     * @return $this
     */
    public function setProductId($product_id)
    {


        /*if (is_null($product_id)) {
            throw new \InvalidArgumentException('non-nullable product_id cannot be null');
        }*/
        $this->container['product_id'] = $product_id;

        return $this;
    }

    /**
     * Gets allow_publish
     *
     * @return bool
     */
    public function getAllowPublish()
    {
        return $this->container['allow_publish'];
    }

    /**
     * Sets allow_publish
     *
     * @param bool $allow_publish allow_publish
     *
     * @return $this
     */
    public function setAllowPublish($allow_publish)
    {


        /*if (is_null($allow_publish)) {
            throw new \InvalidArgumentException('non-nullable allow_publish cannot be null');
        }*/
        $this->container['allow_publish'] = $allow_publish;

        return $this;
    }

    /**
     * Gets main_image_file
     *
     * @return \Ensi\CatalogCacheClient\Dto\FileNullable|null
     */
    public function getMainImageFile()
    {
        return $this->container['main_image_file'];
    }

    /**
     * Sets main_image_file
     *
     * @param \Ensi\CatalogCacheClient\Dto\FileNullable|null $main_image_file main_image_file
     *
     * @return $this
     */
    public function setMainImageFile($main_image_file)
    {

        if (is_null($main_image_file)) {
            array_push($this->openAPINullablesSetToNull, 'main_image_file');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('main_image_file', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['main_image_file'] = $main_image_file;

        return $this;
    }

    /**
     * Gets category_ids
     *
     * @return int[]
     */
    public function getCategoryIds()
    {
        return $this->container['category_ids'];
    }

    /**
     * Sets category_ids
     *
     * @param int[] $category_ids Category IDs from PIM
     *
     * @return $this
     */
    public function setCategoryIds($category_ids)
    {


        /*if (is_null($category_ids)) {
            throw new \InvalidArgumentException('non-nullable category_ids cannot be null');
        }*/
        $this->container['category_ids'] = $category_ids;

        return $this;
    }

    /**
     * Gets brand_id
     *
     * @return int|null
     */
    public function getBrandId()
    {
        return $this->container['brand_id'];
    }

    /**
     * Sets brand_id
     *
     * @param int|null $brand_id Brand ID from PIM
     *
     * @return $this
     */
    public function setBrandId($brand_id)
    {

        if (is_null($brand_id)) {
            array_push($this->openAPINullablesSetToNull, 'brand_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('brand_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['brand_id'] = $brand_id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string $name name
     *
     * @return $this
     */
    public function setName($name)
    {


        /*if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }*/
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets code
     *
     * @return string
     */
    public function getCode()
    {
        return $this->container['code'];
    }

    /**
     * Sets code
     *
     * @param string $code Code to use in URL
     *
     * @return $this
     */
    public function setCode($code)
    {


        /*if (is_null($code)) {
            throw new \InvalidArgumentException('non-nullable code cannot be null');
        }*/
        $this->container['code'] = $code;

        return $this;
    }

    /**
     * Gets description
     *
     * @return string|null
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     *
     * @param string|null $description description
     *
     * @return $this
     */
    public function setDescription($description)
    {

        if (is_null($description)) {
            array_push($this->openAPINullablesSetToNull, 'description');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('description', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets type
     *
     * @return int
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param int $type Product type from ProductTypeEnum from PIM
     *
     * @return $this
     */
    public function setType($type)
    {


        /*if (is_null($type)) {
            throw new \InvalidArgumentException('non-nullable type cannot be null');
        }*/
        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets vendor_code
     *
     * @return string
     */
    public function getVendorCode()
    {
        return $this->container['vendor_code'];
    }

    /**
     * Sets vendor_code
     *
     * @param string $vendor_code Article
     *
     * @return $this
     */
    public function setVendorCode($vendor_code)
    {


        /*if (is_null($vendor_code)) {
            throw new \InvalidArgumentException('non-nullable vendor_code cannot be null');
        }*/
        $this->container['vendor_code'] = $vendor_code;

        return $this;
    }

    /**
     * Gets barcode
     *
     * @return string|null
     */
    public function getBarcode()
    {
        return $this->container['barcode'];
    }

    /**
     * Sets barcode
     *
     * @param string|null $barcode EAN
     *
     * @return $this
     */
    public function setBarcode($barcode)
    {

        if (is_null($barcode)) {
            array_push($this->openAPINullablesSetToNull, 'barcode');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('barcode', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['barcode'] = $barcode;

        return $this;
    }

    /**
     * Gets weight
     *
     * @return float|null
     */
    public function getWeight()
    {
        return $this->container['weight'];
    }

    /**
     * Sets weight
     *
     * @param float|null $weight Net weight in kg
     *
     * @return $this
     */
    public function setWeight($weight)
    {

        if (is_null($weight)) {
            array_push($this->openAPINullablesSetToNull, 'weight');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('weight', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['weight'] = $weight;

        return $this;
    }

    /**
     * Gets weight_gross
     *
     * @return float|null
     */
    public function getWeightGross()
    {
        return $this->container['weight_gross'];
    }

    /**
     * Sets weight_gross
     *
     * @param float|null $weight_gross Gross weight in kg
     *
     * @return $this
     */
    public function setWeightGross($weight_gross)
    {

        if (is_null($weight_gross)) {
            array_push($this->openAPINullablesSetToNull, 'weight_gross');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('weight_gross', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['weight_gross'] = $weight_gross;

        return $this;
    }

    /**
     * Gets width
     *
     * @return float|null
     */
    public function getWidth()
    {
        return $this->container['width'];
    }

    /**
     * Sets width
     *
     * @param float|null $width Width in mm
     *
     * @return $this
     */
    public function setWidth($width)
    {

        if (is_null($width)) {
            array_push($this->openAPINullablesSetToNull, 'width');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('width', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['width'] = $width;

        return $this;
    }

    /**
     * Gets height
     *
     * @return float|null
     */
    public function getHeight()
    {
        return $this->container['height'];
    }

    /**
     * Sets height
     *
     * @param float|null $height Height in mm
     *
     * @return $this
     */
    public function setHeight($height)
    {

        if (is_null($height)) {
            array_push($this->openAPINullablesSetToNull, 'height');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('height', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['height'] = $height;

        return $this;
    }

    /**
     * Gets length
     *
     * @return float|null
     */
    public function getLength()
    {
        return $this->container['length'];
    }

    /**
     * Sets length
     *
     * @param float|null $length Length in mm
     *
     * @return $this
     */
    public function setLength($length)
    {

        if (is_null($length)) {
            array_push($this->openAPINullablesSetToNull, 'length');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('length', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['length'] = $length;

        return $this;
    }

    /**
     * Gets is_adult
     *
     * @return bool
     */
    public function getIsAdult()
    {
        return $this->container['is_adult'];
    }

    /**
     * Sets is_adult
     *
     * @param bool $is_adult Is product 18+
     *
     * @return $this
     */
    public function setIsAdult($is_adult)
    {


        /*if (is_null($is_adult)) {
            throw new \InvalidArgumentException('non-nullable is_adult cannot be null');
        }*/
        $this->container['is_adult'] = $is_adult;

        return $this;
    }

    /**
     * Gets uom
     *
     * @return int|null
     */
    public function getUom()
    {
        return $this->container['uom'];
    }

    /**
     * Sets uom
     *
     * @param int|null $uom Unit of measurement from ProductUomEnum from PIM
     *
     * @return $this
     */
    public function setUom($uom)
    {

        if (is_null($uom)) {
            array_push($this->openAPINullablesSetToNull, 'uom');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('uom', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['uom'] = $uom;

        return $this;
    }

    /**
     * Gets tariffing_volume
     *
     * @return int|null
     */
    public function getTariffingVolume()
    {
        return $this->container['tariffing_volume'];
    }

    /**
     * Sets tariffing_volume
     *
     * @param int|null $tariffing_volume Unit of tariffication from ProductTariffingVolumeEnum from PIM
     *
     * @return $this
     */
    public function setTariffingVolume($tariffing_volume)
    {

        if (is_null($tariffing_volume)) {
            array_push($this->openAPINullablesSetToNull, 'tariffing_volume');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('tariffing_volume', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['tariffing_volume'] = $tariffing_volume;

        return $this;
    }

    /**
     * Gets order_step
     *
     * @return float|null
     */
    public function getOrderStep()
    {
        return $this->container['order_step'];
    }

    /**
     * Sets order_step
     *
     * @param float|null $order_step order_step
     *
     * @return $this
     */
    public function setOrderStep($order_step)
    {

        if (is_null($order_step)) {
            array_push($this->openAPINullablesSetToNull, 'order_step');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('order_step', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['order_step'] = $order_step;

        return $this;
    }

    /**
     * Gets order_minvol
     *
     * @return float|null
     */
    public function getOrderMinvol()
    {
        return $this->container['order_minvol'];
    }

    /**
     * Sets order_minvol
     *
     * @param float|null $order_minvol Minimum quantity for order
     *
     * @return $this
     */
    public function setOrderMinvol($order_minvol)
    {

        if (is_null($order_minvol)) {
            array_push($this->openAPINullablesSetToNull, 'order_minvol');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('order_minvol', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['order_minvol'] = $order_minvol;

        return $this;
    }

    /**
     * Gets price
     *
     * @return int|null
     */
    public function getPrice()
    {
        return $this->container['price'];
    }

    /**
     * Sets price
     *
     * @param int|null $price Final price
     *
     * @return $this
     */
    public function setPrice($price)
    {

        if (is_null($price)) {
            array_push($this->openAPINullablesSetToNull, 'price');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('price', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['price'] = $price;

        return $this;
    }

    /**
     * Gets cost
     *
     * @return int|null
     */
    public function getCost()
    {
        return $this->container['cost'];
    }

    /**
     * Sets cost
     *
     * @param int|null $cost Cost before discount
     *
     * @return $this
     */
    public function setCost($cost)
    {

        if (is_null($cost)) {
            array_push($this->openAPINullablesSetToNull, 'cost');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('cost', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['cost'] = $cost;

        return $this;
    }

    /**
     * Gets gluing_name
     *
     * @return string|null
     */
    public function getGluingName()
    {
        return $this->container['gluing_name'];
    }

    /**
     * Sets gluing_name
     *
     * @param string|null $gluing_name Product group name
     *
     * @return $this
     */
    public function setGluingName($gluing_name)
    {

        if (is_null($gluing_name)) {
            array_push($this->openAPINullablesSetToNull, 'gluing_name');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('gluing_name', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['gluing_name'] = $gluing_name;

        return $this;
    }

    /**
     * Gets gluing_is_main
     *
     * @return bool|null
     */
    public function getGluingIsMain()
    {
        return $this->container['gluing_is_main'];
    }

    /**
     * Sets gluing_is_main
     *
     * @param bool|null $gluing_is_main Is main product of product group
     *
     * @return $this
     */
    public function setGluingIsMain($gluing_is_main)
    {

        if (is_null($gluing_is_main)) {
            array_push($this->openAPINullablesSetToNull, 'gluing_is_main');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('gluing_is_main', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['gluing_is_main'] = $gluing_is_main;

        return $this;
    }

    /**
     * Gets gluing_is_active
     *
     * @return bool|null
     */
    public function getGluingIsActive()
    {
        return $this->container['gluing_is_active'];
    }

    /**
     * Sets gluing_is_active
     *
     * @param bool|null $gluing_is_active Is product group active
     *
     * @return $this
     */
    public function setGluingIsActive($gluing_is_active)
    {

        if (is_null($gluing_is_active)) {
            array_push($this->openAPINullablesSetToNull, 'gluing_is_active');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('gluing_is_active', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['gluing_is_active'] = $gluing_is_active;

        return $this;
    }

    /**
     * Gets discount
     *
     * @return \Ensi\CatalogCacheClient\Dto\ElasticDiscount|null
     */
    public function getDiscount()
    {
        return $this->container['discount'];
    }

    /**
     * Sets discount
     *
     * @param \Ensi\CatalogCacheClient\Dto\ElasticDiscount|null $discount discount
     *
     * @return $this
     */
    public function setDiscount($discount)
    {


        /*if (is_null($discount)) {
            throw new \InvalidArgumentException('non-nullable discount cannot be null');
        }*/
        $this->container['discount'] = $discount;

        return $this;
    }

    /**
     * Gets brand
     *
     * @return \Ensi\CatalogCacheClient\Dto\ElasticBrand|null
     */
    public function getBrand()
    {
        return $this->container['brand'];
    }

    /**
     * Sets brand
     *
     * @param \Ensi\CatalogCacheClient\Dto\ElasticBrand|null $brand brand
     *
     * @return $this
     */
    public function setBrand($brand)
    {


        /*if (is_null($brand)) {
            throw new \InvalidArgumentException('non-nullable brand cannot be null');
        }*/
        $this->container['brand'] = $brand;

        return $this;
    }

    /**
     * Gets categories
     *
     * @return \Ensi\CatalogCacheClient\Dto\ElasticCategory[]|null
     */
    public function getCategories()
    {
        return $this->container['categories'];
    }

    /**
     * Sets categories
     *
     * @param \Ensi\CatalogCacheClient\Dto\ElasticCategory[]|null $categories categories
     *
     * @return $this
     */
    public function setCategories($categories)
    {


        /*if (is_null($categories)) {
            throw new \InvalidArgumentException('non-nullable categories cannot be null');
        }*/
        $this->container['categories'] = $categories;

        return $this;
    }

    /**
     * Gets images
     *
     * @return \Ensi\CatalogCacheClient\Dto\ElasticImage[]|null
     */
    public function getImages()
    {
        return $this->container['images'];
    }

    /**
     * Sets images
     *
     * @param \Ensi\CatalogCacheClient\Dto\ElasticImage[]|null $images images
     *
     * @return $this
     */
    public function setImages($images)
    {


        /*if (is_null($images)) {
            throw new \InvalidArgumentException('non-nullable images cannot be null');
        }*/
        $this->container['images'] = $images;

        return $this;
    }

    /**
     * Gets attributes
     *
     * @return \Ensi\CatalogCacheClient\Dto\ElasticAttribute[]|null
     */
    public function getAttributes()
    {
        return $this->container['attributes'];
    }

    /**
     * Sets attributes
     *
     * @param \Ensi\CatalogCacheClient\Dto\ElasticAttribute[]|null $attributes attributes
     *
     * @return $this
     */
    public function setAttributes($attributes)
    {


        /*if (is_null($attributes)) {
            throw new \InvalidArgumentException('non-nullable attributes cannot be null');
        }*/
        $this->container['attributes'] = $attributes;

        return $this;
    }

    /**
     * Gets gluing
     *
     * @return \Ensi\CatalogCacheClient\Dto\Gluing[]|null
     */
    public function getGluing()
    {
        return $this->container['gluing'];
    }

    /**
     * Sets gluing
     *
     * @param \Ensi\CatalogCacheClient\Dto\Gluing[]|null $gluing gluing
     *
     * @return $this
     */
    public function setGluing($gluing)
    {


        /*if (is_null($gluing)) {
            throw new \InvalidArgumentException('non-nullable gluing cannot be null');
        }*/
        $this->container['gluing'] = $gluing;

        return $this;
    }

    /**
     * Gets nameplates
     *
     * @return \Ensi\CatalogCacheClient\Dto\ElasticNameplate[]|null
     */
    public function getNameplates()
    {
        return $this->container['nameplates'];
    }

    /**
     * Sets nameplates
     *
     * @param \Ensi\CatalogCacheClient\Dto\ElasticNameplate[]|null $nameplates nameplates
     *
     * @return $this
     */
    public function setNameplates($nameplates)
    {


        /*if (is_null($nameplates)) {
            throw new \InvalidArgumentException('non-nullable nameplates cannot be null');
        }*/
        $this->container['nameplates'] = $nameplates;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset): mixed
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
    * Convert object to array
    *
    * @return array
    */
    public function toArray()
    {
        return json_decode(json_encode(ObjectSerializer::sanitizeForSerialization($this)), true);
    }
}


